/* 				DATA BASE FORMAT
 * 				database file
writer	feature1.....	....	feature16.... 		.....feature32
number
		mean1 dev1 mean2 dev2 mean3 dev3 ..........     mean16 dev16.
*/

/* finaldata file
 * 
 * writer  mean1 dev1 mean2 dev2 mean3 dev3...............mean32 				dev32.
 * number									 (mean of 32th feature) (std dev of 32th fea)
 *
 */

int  MAX_PAGE_PER_USER=10;

int create_database();
void write_database(int writer,float *mean_dev);
void write_final_data(int roll);
void find_writer(float *curr_feature);
float mean(float **image,int h_image,int w_image);
float std_deviation(float **image,int h_image, int w_image,float mea);


/*
int main(){
	int opt;
	char file[50];
	
	printf("GIVE OPTIONS\n");
	printf("1 For Find Writer\n");
	printf("2 For Enter Some pages for the writer\n");
	printf("3 Exit\n");
	
	scanf("%d",&opt);
	switch(opt){
		case 1: 
			printf("Give the Input File Name\n");
			scanf("%s"&file);
			printf("Case 1 Processing.....\n");
			work(-1,file);
			break;
		case 2: 
			printf("Case 2 Processing.....\n");
			create_database();
			break;
		case 3: 
			exit(1);
			break;
	}		
}	
*/
//return -1 on failing 1 on success
int create_database(){
	int count,start,roll,i,temp;
	FILE *fp,*fp1;
	char *name,con[50];
	float *feature,m;
	int flag=0,opt,user;
	name= (char *)malloc(sizeof(char)*100);
	
	system("clear");
    printf("\t\tEnter the Roll No for this User\n");
    scanf("%d",&roll);
    printf("\t\tEnter the Count of Pages for this User\n");
    scanf("%d",&count);
    printf("\t\tEnter the starting number of the page for this User\n");
    scanf("%d",&start);
	
	fp=fopen("rollno","r");
	if(fp!=NULL){
		while(fscanf(fp,"%d",&temp)!=EOF){
			if(temp==roll){
				printf("\t\tThis user exits in database \n");
				printf("\t\tDo you want to add more papers then Press 1 ");
				printf("\n\t\tElse press 2\n");
				scanf("%d",&opt);
				if(opt!=1)return -1; //return when don't want to add more paper of this user
				flag=1;
			}	
		}
		fclose(fp);
	}
	if(flag!=1){ //add this roll no to data base in file name "rollno"
		fp=fopen("rollno","a");
		fprintf(fp,"%d\n",roll);
		fclose(fp);
	}
	if(flag==1){
		printf("\t\tThis user already exits. Adding more pages...\n");
		fp=fopen("finaldata","r");
		fp1=fopen("temp","w");
		
		fscanf(fp,"%d",&user);
		while(!feof(fp)){
			if(user==roll){
				for(i=0;i<64;i++){
					fscanf(fp,"%f",&m);
				}
			}
			else{
				fprintf(fp1,"%d",user);
				for(i=0;i<64;i++){
					fscanf(fp,"%f",&m);
					fprintf(fp1," %f",m);
				}
				fprintf(fp1,"\n");
			}
			fscanf(fp,"%d",&user);			
		}
		fclose(fp);
		fclose(fp1);
		system("cp temp finaldata");
		system("rm temp");
	}
	printf("%d roll no\n",roll);	
	
    sprintf(name,"%d",roll);
    for(i=1;i<=count; i++,start++){
       sprintf(con,"_%d.pgm",start);
       name=strcat(name,con);
	   printf("name=%s\n",name);
	   work(roll,name);	
       sprintf(name,"%d",roll);
    }	
	
	write_final_data(roll);// have to modify the final database
	return 1;
}

//function that write into the database
void write_database(int writer,float *mean_dev){
	FILE *fp;
	int i;
	fp=fopen("database","a");
	if(fp==NULL){
		printf("\t\tSome problem in opening database file \n");
		exit(0);
	}			
	fprintf(fp,"%d",writer);
	for(i=0;i<32;i++)
		fprintf(fp," %f",mean_dev[i]);
	fprintf(fp,"\n");
	fclose(fp);
	return;	
}


void write_final_data(int roll){
	FILE *fp;
	int i,j,k,writer,pages;
	float mean_dev[64],**feature;
	char *proc;
	char temp[200];
	int flag=0;
	float mea=0,std=0,arbit;

	feature =(float **)malloc(sizeof(float *)*MAX_PAGE_PER_USER);
	for(i=0;i<MAX_PAGE_PER_USER;i++){
		feature[i]=(float *)malloc(sizeof(float)*32);
	}	
	
	fp=fopen("database","r");
//printf("fp=%d\n",fp);	

	pages=0;
		fscanf(fp,"%d",&writer);
	while(!feof(fp)){
		if(writer==roll){
			if(!(pages<MAX_PAGE_PER_USER)){
				//reallocation of the array
				printf("\t\tRellocation of Memory\n");
				MAX_PAGE_PER_USER +=4;
				feature = (float **)realloc(feature,(sizeof(float *)*MAX_PAGE_PER_USER));
				for(i=0;i<MAX_PAGE_PER_USER;i++){
					feature[i]=(float *)realloc(feature[i],(sizeof(float)*32));
				}					
			}
			flag=1;
			for(i=0;i<32;i++){
				fscanf(fp,"%f",&feature[pages][i]);
			}
			pages++;
		}
		else{
			for(i=0;i<32;i++){
				fscanf(fp,"%f",&arbit);
			}			
		}	
		fscanf(fp,"%d",&writer);
	}
	fclose(fp);
	
	if(pages==0) printf("Roll No %d Not Found \n",roll);
	else{
		printf("\t\tNumber of Rows For this user =%d\n",pages);
		for(i=0,k=0;i<32,k<64;i+=1,k+=2){
			for(mea=0,j=0;j<pages;j++){
				mea +=feature[j][i];
			}
			mea= mea/pages;
			for(std=0,j=0;j<pages;j++){
				std +=((feature[j][i]-mea)*(feature[j][i]-mea));
			}
			std =(float)sqrt((double)std/pages);
			mean_dev[k]=mea;
			mean_dev[k+1]=std;
			printf("\t\tFINAL mean=%f std=%f\n",mea,std);
		}	
	}
	
	fp=fopen("finaldata","a");
	fprintf(fp,"%d",roll);
	for(i=0;i<64;i++)
		fprintf(fp," %f",mean_dev[i]);
	fprintf(fp,"\n");
	fclose(fp);
	return;
}	


//function to find the writer
void find_writer(float *curr_feature){
	int writer,i,min,m=1;
	float d,min_d,feature[64];
	char *proc,temp[200];
	FILE *fp;
	int flag=0;
	
	fp=fopen("finaldata","r");

		fscanf(fp,"%d",&writer);
		printf("writer= %d  \n",writer);
	while(!feof(fp)){
		//printf("count %d\n",m++);
		for(i=0;i<64;i++){
			fscanf(fp,"%f",&feature[i]);
		}
		for(d=0,i=0;i<32;i++){
			d +=((curr_feature[i]-feature[2*i])*(curr_feature[i]-feature[2*i]))/(feature[2*i+1]*feature[2*i+1]);
		}
	//printf("In find Writer 2 d=%f\n",d);
		if(flag==0){
			flag=1;
			min_d=d;
			min=writer;
			//printf("writer=%d min=%d\n",writer,min);
		}	
		if(d<min_d){
			min=writer;
			min_d=d;
			//printf("writer=%d min=%d\n",writer,min);
		}	
		fscanf(fp,"%d",&writer);
		//printf("writer= %d  \n",writer);
	}
	printf("\t\tTHE WRITER NUMBER IS %d\n",min);
	fclose(fp);
	return;
} 
//function to calculate the mean of a image

float mean(float **image,int h_image,int w_image){
	int count=0,i,j;
	float mea=0;
	for(i=0;i<h_image;i++){
		for(j=0;j<w_image;j++){
			mea +=image[i][j];
			count++;
		}	
	}
	return mea/count;
}
// function to calculate the standard deviation of the image
float std_deviation(float **image,int h_image, int w_image,float mea){
	
	int i,j,count;
	float dev;

 	//mea=mean(image,h_image,w_image);
	
	for(count=0,dev=0,i=0;i<h_image;i++){
		for(j=0;j<w_image;j++){
			dev += ((image[i][j]-mea)*(image[i][j]-mea));
			count++;
		}	
	}
	return (float)sqrt((double)dev/count);
}	
